<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns="http://www.imsglobal.org/xsd/imsqti_v2p0" xmlns:imsqti="http://www.imsglobal.org/xsd/imsqti_v2p0" xmlns:m="http://www.w3.org/1998/Math/MathML" exclude-result-prefixes="imsqti">
	<xsl:output method="xml" version="1.0" encoding="UTF-8" indent="yes"/>
	<!--
	(c) 2004 SURF SiX http://e-learning.surf.nl/SiX/english
	Version: 0.2
	Author: Pierre Gorissen - P.Gorissen@Fontys.nl
	This XSLT stylesheet creates a profile for QTI item which shows what support  the item needs from the system
	All reuse permitted provided this notice remains intact
	-->
	<!-- TODO
	* check for language in item
	* ....
	
	-->
	<!-- VERSION HISTORY
	Version 0.1 - first version, works with QTI ITEM V2.0 draft
	Version 0.2 - updated for changes in QTI V2.0 final
	-->
	<xsl:template match="/">
		<xsl:comment> 

Created by the QTI2IMSMD XLST script version 0.2
Assessment Item identifier: <xsl:value-of select="imsqti:assessmentItem/attribute::identifier"/>

		</xsl:comment>
		<contentProfile xmlns="http://www.imsglobal.org/xsd/imsqti_v2p0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://www.imsglobal.org/xsd/imsqti_v2p0 imsqti_v2p0.xsd">
			<xsl:call-template name="compositeItem"/>
			<xsl:apply-templates select="imsqti:assessmentItem" mode="adaptiveItem"/>
			<xsl:apply-templates select="imsqti:assessmentItem" mode="timeDependent"/>
			<xsl:call-template name="templateItem"/>
			<xsl:call-template name="textElements"/>
			<xsl:call-template name="listElements"/>
			<xsl:call-template name="objectElements"/>
			<xsl:apply-templates select="imsqti:assessmentItem" mode="objectType"/>
			<xsl:call-template name="presentationElements"/>
			<xsl:call-template name="tableElements"/>
			<xsl:call-template name="imageElements"/>
			<xsl:call-template name="hypertextElements"/>
			<xsl:call-template name="mathElements"/>
			<xsl:call-template name="feedbackIntegrated"/>
			<xsl:call-template name="feedbackModal"/>
			<xsl:call-template name="rubricElements"/>
			<xsl:call-template name="printedVariables"/>
			<xsl:apply-templates select="imsqti:assessmentItem" mode="interactionType"/>
			<xsl:call-template name="responseRules"/>
			<xsl:apply-templates select="imsqti:assessmentItem" mode="templateType"/>
			<xsl:call-template name="rounding"/>
			<xsl:call-template name="regexp"/>
		</contentProfile>
	</xsl:template>
	<xsl:template match="imsqti:assessmentItem" mode="timeDependent">
		<timeDependent>
			<xsl:value-of select="attribute::timeDependent"/>
		</timeDependent>
	</xsl:template>
	<xsl:template match="imsqti:assessmentItem" mode="objectType">
		<xsl:apply-templates select="//imsqti:object" mode="objectType"/>
	</xsl:template>
	<xsl:template match="//imsqti:object" mode="objectType">
		<objectType>
			<xsl:value-of select="attribute::type"/>
		</objectType>
	</xsl:template>
	<xsl:template match="imsqti:assessmentItem" mode="templateType">
		<xsl:apply-templates select="//imsqti:responseProcessing" mode="templateType"/>
	</xsl:template>
	<xsl:template match="//imsqti:responseProcessing" mode="templateType">
		<xsl:choose>
			<xsl:when test="attribute::template != ''">
				<rpTemplate>
					<xsl:value-of select="attribute::template"/>
				</rpTemplate>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template match="imsqti:assessmentItem" mode="interactionType">
		<xsl:apply-templates select="//imsqti:associateInteraction[1]
				| //imsqti:choiceInteraction[1]
				| //imsqti:choiceMatrixInteraction[1]
				| //imsqti:customInteraction[1]
				| //imsqti:drawingInteraction[1]
				| //imsqti:endAttemptInteraction[1]
				| //imsqti:extendedTextInteraction[1]
				| //imsqti:gapMatchInteraction[1]
				| //imsqti:graphicAssociateInteraction[1]
				| //imsqti:graphicGapMatchInteraction[1]
				| //imsqti:graphicOrderInteraction[1]
				| //imsqti:hotspotInteraction[1]
				| //imsqti:hottextInteraction[1]
				| //imsqti:matchInteraction[1]
				| //imsqti:orderInteraction[1]
				| //imsqti:positionObjectInteraction[1]
				| //imsqti:selectPointInteraction[1]
				| //imsqti:sliderInteraction[1]
				| //imsqti:inlineChoiceInteraction[1]
				| //imsqti:textEntryInteraction[1]
				| //imsqti:uploadInteraction[1]" mode="interactionType"/>
	</xsl:template>
	<xsl:template match="//imsqti:associateInteraction
				| //imsqti:choiceInteraction
				| //imsqti:choiceMatrixInteraction
				| //imsqti:customInteraction
				| //imsqti:drawingInteraction
				| //imsqti:endAttemptInteraction
				| //imsqti:extendedTextInteraction
				| //imsqti:gapMatchInteraction
				| //imsqti:graphicAssociateInteraction
				| //imsqti:graphicGapMatchInteraction
				| //imsqti:graphicOrderInteraction
				| //imsqti:hotspotInteraction
				| //imsqti:hottextInteraction
				| //imsqti:matchInteraction
				| //imsqti:orderInteraction
				| //imsqti:positionObjectInteraction
				| //imsqti:selectPointInteraction
				| //imsqti:sliderInteraction
				| //imsqti:inlineChoiceInteraction
				| //imsqti:textEntryInteraction
				| //imsqti:uploadInteraction" mode="interactionType">
		<interactionType>
			<xsl:value-of select="name()"/>
		</interactionType>
	</xsl:template>
	<xsl:template name="templateItem">
		<xsl:param name="tlist" select="//imsqti:templateProcessing"/>
		<xsl:param name="count">1</xsl:param>
		<templates>
			<xsl:choose>
				<xsl:when test="$count &lt;= count($tlist)">
					<xsl:text>true</xsl:text>
				</xsl:when>
				<xsl:otherwise>
					<xsl:text>false</xsl:text>
				</xsl:otherwise>
			</xsl:choose>
		</templates>
	</xsl:template>
	<xsl:template name="compositeItem">
		<xsl:param name="ilist" select="//imsqti:associateInteraction
				| //imsqti:choiceInteraction
				| //imsqti:choiceMatrixInteraction
				| //imsqti:customInteraction
				| //imsqti:drawingInteraction
				| //imsqti:endAttemptInteraction
				| //imsqti:extendedTextInteraction
				| //imsqti:gapMatchInteraction
				| //imsqti:graphicAssociateInteraction
				| //imsqti:graphicGapMatchInteraction
				| //imsqti:graphicOrderInteraction
				| //imsqti:hotspotInteraction
				| //imsqti:hottextInteraction
				| //imsqti:matchInteraction
				| //imsqti:orderInteraction
				| //imsqti:positionObjectInteraction
				| //imsqti:selectPointInteraction
				| //imsqti:sliderInteraction
				| //imsqti:inlineChoiceInteraction
				| //imsqti:textEntryInteraction
				| //imsqti:uploadInteraction"/>
		<xsl:param name="count">1</xsl:param>
		<composite>
			<xsl:choose>
				<xsl:when test="$count &lt; count($ilist)">
					<xsl:text>true</xsl:text>
				</xsl:when>
				<xsl:otherwise>
					<xsl:text>false</xsl:text>
				</xsl:otherwise>
			</xsl:choose>
		</composite>
	</xsl:template>
	<xsl:template match="imsqti:assessmentItem" mode="adaptiveItem">
		<adaptive>
			<xsl:value-of select="attribute::adaptive"/>
		</adaptive>
	</xsl:template>
	<xsl:template name="feedbackIntegrated">
		<xsl:param name="fblist" select="//imsqti:feedbackInline | //imsqti:feedbackBlock"/>
		<xsl:param name="count">1</xsl:param>
		<feedbackIntegrated>
			<xsl:choose>
				<xsl:when test="$count &lt;= count($fblist)">
					<xsl:text>true</xsl:text>
				</xsl:when>
				<xsl:otherwise>
					<xsl:text>false</xsl:text>
				</xsl:otherwise>
			</xsl:choose>
		</feedbackIntegrated>
	</xsl:template>
	<xsl:template name="feedbackModal">
		<xsl:param name="fblist" select="//imsqti:feedbackModal"/>
		<xsl:param name="count">1</xsl:param>
		<feedbackModal>
			<xsl:choose>
				<xsl:when test="$count &lt;= count($fblist)">
					<xsl:text>true</xsl:text>
				</xsl:when>
				<xsl:otherwise>
					<xsl:text>false</xsl:text>
				</xsl:otherwise>
			</xsl:choose>
		</feedbackModal>
	</xsl:template>
	<xsl:template name="textElements">
		<xsl:param name="ilist" select="//imsqti:abbr
				| //imsqti:acronym
				| //imsqti:address
				| //imsqti:blockquote
				| //imsqti:br
				| //imsqti:cite
				| //imsqti:code
				| //imsqti:dfn
				| //imsqti:div
				| //imsqti:em
				| //imsqti:h1
				| //imsqti:h2
				| //imsqti:h3
				| //imsqti:h4
				| //imsqti:h5
				| //imsqti:h6
				| //imsqti:kbd
				| //imsqti:p
				| //imsqti:pre
				| //imsqti:q
				| //imsqti:samp
				| //imsqti:span
				| //imsqti:strong
				| //imsqti:var"/>
		<xsl:param name="count">1</xsl:param>
		<textElements>
			<xsl:choose>
				<xsl:when test="$count &lt;= count($ilist)">
					<xsl:text>true</xsl:text>
				</xsl:when>
				<xsl:otherwise>
					<xsl:text>false</xsl:text>
				</xsl:otherwise>
			</xsl:choose>
		</textElements>
	</xsl:template>
	<xsl:template name="listElements">
		<xsl:param name="ilist" select="//imsqti:dd
				| //imsqti:dt
				| //imsqti:dl
				| //imsqti:ol
				| //imsqti:ul
				| //imsqti:li"/>
		<xsl:param name="count">1</xsl:param>
		<listElements>
			<xsl:choose>
				<xsl:when test="$count &lt;= count($ilist)">
					<xsl:text>true</xsl:text>
				</xsl:when>
				<xsl:otherwise>
					<xsl:text>false</xsl:text>
				</xsl:otherwise>
			</xsl:choose>
		</listElements>
	</xsl:template>
	<xsl:template name="objectElements">
		<xsl:param name="ilist" select="//imsqti:object"/>
		<xsl:param name="count">1</xsl:param>
		<objectElements>
			<xsl:choose>
				<xsl:when test="$count &lt;= count($ilist)">
					<xsl:text>true</xsl:text>
				</xsl:when>
				<xsl:otherwise>
					<xsl:text>false</xsl:text>
				</xsl:otherwise>
			</xsl:choose>
		</objectElements>
	</xsl:template>
	<xsl:template name="presentationElements">
		<xsl:param name="ilist" select="//imsqti:b
				| //imsqti:big
				| //imsqti:hr
				| //imsqti:i
				| //imsqti:small
				| //imsqti:sub
				| //imsqti:sup
				| //imsqti:tt"/>
		<xsl:param name="count">1</xsl:param>
		<presentationElements>
			<xsl:choose>
				<xsl:when test="$count &lt;= count($ilist)">
					<xsl:text>true</xsl:text>
				</xsl:when>
				<xsl:otherwise>
					<xsl:text>false</xsl:text>
				</xsl:otherwise>
			</xsl:choose>
		</presentationElements>
	</xsl:template>
	<xsl:template name="tableElements">
		<xsl:param name="ilist" select="//imsqti:caption
				| //imsqti:col
				| //imsqti:colgroup
				| //imsqti:table
				| //imsqti:thead
				| //imsqti:tfoot
				| //imsqti:tbody
				| //imsqti:td
				| //imsqti:th
				| //imsqti:tr"/>
		<xsl:param name="count">1</xsl:param>
		<tableElements>
			<xsl:choose>
				<xsl:when test="$count &lt;= count($ilist)">
					<xsl:text>true</xsl:text>
				</xsl:when>
				<xsl:otherwise>
					<xsl:text>false</xsl:text>
				</xsl:otherwise>
			</xsl:choose>
		</tableElements>
	</xsl:template>
	<xsl:template name="imageElements">
		<xsl:param name="ilist" select="//imsqti:img"/>
		<xsl:param name="count">1</xsl:param>
		<imageElement>
			<xsl:choose>
				<xsl:when test="$count &lt;= count($ilist)">
					<xsl:text>true</xsl:text>
				</xsl:when>
				<xsl:otherwise>
					<xsl:text>false</xsl:text>
				</xsl:otherwise>
			</xsl:choose>
		</imageElement>
		<xsl:choose>
			<xsl:when test="$count &lt;= count($ilist)">
				<imageType>
					<xsl:text>cannot automatically determine imagetypes used</xsl:text>
				</imageType>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="hypertextElements">
		<xsl:param name="ilist" select="//imsqti:a"/>
		<xsl:param name="count">1</xsl:param>
		<hypertextElement>
			<xsl:choose>
				<xsl:when test="$count &lt;= count($ilist)">
					<xsl:text>true</xsl:text>
				</xsl:when>
				<xsl:otherwise>
					<xsl:text>false</xsl:text>
				</xsl:otherwise>
			</xsl:choose>
		</hypertextElement>
	</xsl:template>
	<xsl:template name="mathElements">
		<xsl:param name="ilist" select="//m:math"/>
		<xsl:param name="count">1</xsl:param>
		<xsl:param name="tlist" select="//imsqti:templateProcessing"/>
		<mathElement>
			<xsl:choose>
				<xsl:when test="$count &lt;= count($ilist)">
					<xsl:text>true</xsl:text>
				</xsl:when>
				<xsl:otherwise>
					<xsl:text>false</xsl:text>
				</xsl:otherwise>
			</xsl:choose>
		</mathElement>
		<mathVariable>
			<xsl:choose>
				<xsl:when test="$count &lt;= count($ilist) and $count &lt;= count($tlist)">
						<xsl:text>cannot automatically determine if template variable names are used in MathML</xsl:text>
				</xsl:when>
				<xsl:otherwise>
					<xsl:text>false</xsl:text>
				</xsl:otherwise>
			</xsl:choose>
		</mathVariable>
	</xsl:template>
	<xsl:template name="rubricElements">
		<xsl:param name="ilist" select="//imsqti:rubric"/>
		<xsl:param name="count">1</xsl:param>
		<rubric>
			<xsl:choose>
				<xsl:when test="$count &lt;= count($ilist)">
					<xsl:text>true</xsl:text>
				</xsl:when>
				<xsl:otherwise>
					<xsl:text>false</xsl:text>
				</xsl:otherwise>
			</xsl:choose>
		</rubric>
	</xsl:template>
	<xsl:template name="printedVariables">
		<xsl:param name="ilist" select="//imsqti:printedVariable"/>
		<xsl:param name="count">1</xsl:param>
		<printedVariables>
			<xsl:choose>
				<xsl:when test="$count &lt;= count($ilist)">
					<xsl:text>true</xsl:text>
				</xsl:when>
				<xsl:otherwise>
					<xsl:text>false</xsl:text>
				</xsl:otherwise>
			</xsl:choose>
		</printedVariables>
	</xsl:template>
	<xsl:template name="responseRules">
		<xsl:param name="templatelist" select="//imsqti:responseProcessing[@template!='']"/>
		<xsl:param name="totallist" select="//imsqti:responseProcessing"/>
		<responseRules>
			<xsl:choose>
				<xsl:when test="count($totallist) != count($templatelist)">
					<xsl:text>true</xsl:text>
				</xsl:when>
				<xsl:otherwise>
					<xsl:text>false</xsl:text>
				</xsl:otherwise>
			</xsl:choose>
		</responseRules>
	</xsl:template>
	<xsl:template name="rounding">
		<xsl:param name="ilist" select="//imsqti:equalRounded
		|//imsqti:printedVariables/attribute::format"/>
		<xsl:param name="count">1</xsl:param>
		<rounding>
			<xsl:choose>
				<xsl:when test="$count &lt;= count($ilist)">
					<xsl:text>true</xsl:text>
				</xsl:when>
				<xsl:otherwise>
					<xsl:text>false</xsl:text>
				</xsl:otherwise>
			</xsl:choose>
		</rounding>
	</xsl:template>
	<xsl:template name="regexp">
		<xsl:param name="ilist" select="//imsqti:patternMatch
				|//imsqti:textEntryInteraction/attribute::patternMask
				|//imsqti:extendedTextInteraction/attribute::patternMask"/>
		<xsl:param name="count">1</xsl:param>
		<regexp>
			<xsl:choose>
				<xsl:when test="$count &lt;= count($ilist)">
					<xsl:text>true</xsl:text>
				</xsl:when>
				<xsl:otherwise>
					<xsl:text>false</xsl:text>
				</xsl:otherwise>
			</xsl:choose>
		</regexp>
	</xsl:template>
</xsl:stylesheet>
